%Pindyck,Rubinfeld (1997) - example 6.4

clear all
close all
clc

tic %meric casu - pro zjisteni rychlosti programu

load EX64.dat

date = EX64(:,1); %rok 1960-1985
Q = EX64(:,2); %log mnoztvi distribuovane energie
P = EX64(:,3); %log ceny (za jednotku, v dolarech 1975)
INC = EX64(:,4); %duchod na jednu domacnost (v dolarech 1975)

n = length(Q);

YEAR = (1:n)';


%Odhady Gibbsovym vzorkovacem za predpokladu nezname heteroskedasticity

y = Q;
X = [ones(size(y)) YEAR P log(INC)];

[n,k] = size(X);

%prior hyperparameters
b0 = [3.5 0.1 -0.5 0.5]';

s02 = 0.1^2;
h0 = 1/s02;
varb0 = [18^2 0.1^2 0.1^2 0.25^2]';
nu0 = 5;
V0 = diag(varb0);

S = 30000;
S0 = 5000;
S1 = S-S0;


b_Gibbs = zeros(k,S);
h_Gibbs = zeros(1,S);
lambda_Gibbs = zeros(n,S);
nu_lambda_rw = zeros(1,S);

count_rw = 0; %ta akcepotvanch kandidt

%RW M-H algoritmus pro nu_lambda (jedna promenna)
postvar = 1;
d=3;
vscale_rw=d*postvar;
nu_lambda0 = 5; %apriorni stredni hodnota pro lambda

lambda0 = ones(n,1);
Omega = diag(lambda0.^-1); %kov. matice Omega - predpoklad lambda0_i = 1
invOmega = inv(Omega);

%Gibbsuv vzorkovac
b_Omega =inv(X'*invOmega*X)*X'*invOmega*y;
h_Gibbs0 = h0;
V1 = inv(inv(V0)+h_Gibbs0*X'*invOmega*X);
b1 = V1*(inv(V0)*b0+h_Gibbs0*X'*invOmega*X*b_Omega);
b_Gibbs(:,1)=b1+norm_rnd(V1);
%b_Gibbs(:,1)=mvnrnd(b1,V1)';

nu1 =n+nu0;
s12 = 1/nu1*((y-X*b_Gibbs(:,1))'*invOmega*(y-X*b_Gibbs(:,1))+nu0*s02);
    %A=nu1/2; %jinak definovana funkce gamma v ramci gamrnd, nez v Koopovi
    %B=2*inv(s12)/nu1;
%h_Gibbs(:,1)=gamrnd(A,B);
h_Gibbs(:,1)=gamm_rnd(1,1,.5*nu1,.5*nu1*s12);

epsilon = y-X*b_Gibbs(:,1); %vypocet epsilonu (na zaklade beta)
for ii=1:n
    AA = .5*(nu_lambda0+1);
    BB = .5*(h_Gibbs(:,1)*epsilon(ii)^2+nu_lambda0);
    lambda_Gibbs(ii,1)=gamm_rnd(1,1,AA,BB); %Koop (6.25)
end

%R-W M-H pro nu_lambda
    nu_lambda_can_rw = nu_lambda0 + norm_rnd(vscale_rw); %kandidat
    if nu_lambda_can_rw <=0 %nulova akceptacni pravdepodobnost pro zaporne nebo nulove kandidaty!
        log_accept_rw = -inf;
    else
    log_accept_rw = min(nu_lambda_post(nu_lambda_can_rw,nu_lambda0,lambda_Gibbs(:,1))-nu_lambda_post(nu_lambda0,nu_lambda0,lambda_Gibbs(:,1)),0);
    end
    if log_accept_rw > log(rand)
        nu_lambda_rw(:,1)=nu_lambda_can_rw;
        count_rw=count_rw+1;
    else
        nu_lambda_rw(:,1)=nu_lambda0;
    end



for i=2:S
    Omega = diag(lambda_Gibbs(:,i-1).^-1); %kov. matice Omega 
    invOmega = inv(Omega);
    b_Omega =inv(X'*invOmega*X)*X'*invOmega*y;
    
    V1 = inv(inv(V0)+h_Gibbs(:,i-1)*X'*invOmega*X);
    b1 = V1*(inv(V0)*b0+h_Gibbs(:,i-1)*X'*invOmega*X*b_Omega);
    %(nesystematicky zasah -- nekdy nastava numericky problem, ze Matlab nevezme V1 jako pozitivne
    %definitni matici => ignorujeme chybu a "udelame z V1 pozitivne definitni
    %prictenim maleho cisla 
    try
        b_Gibbs(:,i)=b1+norm_rnd(V1);
    catch
        b_Gibbs(:,i)=b1+norm_rnd(V1+0.000000001);
    end
    %b_Gibbs(:,1)=mvnrnd(b1,V1)';

    nu1 =n+nu0;
    s12 = 1/nu1*((y-X*b_Gibbs(:,i))'*invOmega*(y-X*b_Gibbs(:,i))+nu0*s02);
    %A=nu1/2; %jinak definovana funkce gamma v ramci gamrnd, nez v Koopovi
    %B=2*inv(s12)/nu1;
    %h_Gibbs(:,1)=gamrnd(A,B);
    h_Gibbs(:,i)=gamm_rnd(1,1,.5*nu1,.5*nu1*s12);

    epsilon = y-X*b_Gibbs(:,i); %vypocet epsilonu (na zaklade beta)
    for ii=1:n
        AA = .5*(nu_lambda_rw(:,i-1)+1);
        BB = .5*(h_Gibbs(:,i)*epsilon(ii)^2+nu_lambda_rw(:,i-1));
        lambda_Gibbs(ii,i)=gamm_rnd(1,1,AA,BB); %Koop (6.25)
    end

%R-W M-H pro nu_lambda
    nu_lambda_can_rw = nu_lambda_rw(:,i-1) + norm_rnd(vscale_rw); %kandidat
    if nu_lambda_can_rw <=0 %nulova akceptacni pravdepodobnost pro zaporne nebo nulove kandidaty!
        log_accept_rw =-inf;
    else
    log_accept_rw = min(nu_lambda_post(nu_lambda_can_rw,nu_lambda0,lambda_Gibbs(:,i))-nu_lambda_post(nu_lambda_rw(:,i-1),nu_lambda0,lambda_Gibbs(:,i)),0);
    end
    if log_accept_rw > log(rand)
        nu_lambda_rw(:,i)=nu_lambda_can_rw;
        count_rw=count_rw+1;
    else
        nu_lambda_rw(:,i)=nu_lambda_rw(:,i-1);
    end
   
end

%vyhozeni prvnich S0 vzorku
b_S1 = b_Gibbs(:,S0+1:S);
h_S1 = h_Gibbs(:,S0+1:S);
%lambda_S1 = lambda_Gibbs(:,S0+1:S);
nu_lambda_S1 = nu_lambda_rw(:,S0+1:S);

b_mean = mean(b_S1,2); %posteriorni stredni hodnota 
h_mean = mean(h_S1);
nu_lambda_mean = mean(nu_lambda_S1);
b_var = mean(b_S1.^2,2)-b_mean.^2; %posteriorni rozptyl
h_var = mean(h_S1.^2)-h_mean.^2;
nu_lambda_var = mean(nu_lambda_S1.^2,2)-nu_lambda_mean.^2;


accept_ratio_rw = count_rw/S;


%KONVERGENCNI DIAGNOSTIKY - Gewekova CD pomoci funkce momentg
alldraws = [b_S1' h_S1' nu_lambda_S1'];
%The function momentg is taken from LeSage's toolbox
%it inputs all Gibbs draws and produces posterior
%mean, standard deviation, nse and rne
%it calculates what the book calls S(0) in various ways
%see momentg.m for more details
result = momentg(alldraws);
means=[result.pmean]';
stdevs=[result.pstd]';
nse=[result.nse]';
nse1=[result.nse1]';
nse2=[result.nse2]';
nse3=[result.nse3]';
%calculate Geweke convergence diagnostic based on first .1
%and last .4 of draws
idraw1= round(.1*S1); %prvnich 10%
result = momentg(alldraws(1:idraw1,:));
meansa=[result.pmean]';
nsea=[result.nse1]';

idraw2= round(.6*S1)+1; %poslednich 40%
result = momentg(alldraws(idraw2:S1,:));
meansb=[result.pmean]';
nseb=[result.nse1]';

CD = (meansa - meansb)./(nsea+nseb);



%HPDI pro beta a nu_lambda
[k_b,l_b] = size(b_S1);
[k_a,l_a] = size(nu_lambda_S1);

hperc=0.95; %HPDI
HPDIb_l = zeros(k_b,1);
HPDIb_u = zeros(k_b,1);
for j=1:k_b
    botperc=round((1-hperc)/2*l_b);
    topperc=round((1+hperc)/2*l_b);
    temp = sort(b_S1(j,:));
    HPDIb_u(j)=temp(topperc);
    HPDIb_l(j)=temp(botperc);
end

HPDIa_l = zeros(k_a,1);
HPDIa_u = zeros(k_a,1);
for j=1:k_a
    botperc=round((1-hperc)/2*l_a);
    topperc=round((1+hperc)/2*l_a);
    temp = sort(nu_lambda_S1(j,:));
    HPDIa_u(j)=temp(topperc);
    HPDIa_l(j)=temp(botperc);
end








t = toc;

%Prezentace vysledku, grafy
fprintf('Prior and posterior means for beta (std. deviations in parentheses)\n');
fprintf('                Prior       Posterior      NSE         Geweke CD             %3.1f%% HPDI \n',hperc*100);
fprintf('   ------------------------------------\n');

figure

for i=1:k
fprintf('Beta%1.0f     %12.4f   %12.4f   %10.4f   %10.4f   [%10.4f, %10.4f]\n',[i b0(i) b_mean(i) nse(i) CD(i) HPDIb_l(i) HPDIb_u(i)]);
fprintf('           (%12.4f) (%12.4f)\n',[sqrt(varb0(i)) sqrt(b_var(i))]);

    [f,xi] = ksdensity(b_S1(i,:));
    subplot(3,2,i)
    plot(xi,f)
    xlabel(['\beta_' num2str(i)])
end

figure
for i=1
fprintf('nu_lambda  %12.4f        %12.4f   %10.4f   %10.4f   [%10.4f, %10.4f]\n',[nu_lambda0 nu_lambda_mean nse(k+1+i) CD(k+1+i) HPDIa_l(i) HPDIa_u(i)]);
fprintf('           (%12.4f)        (%12.4f)\n',[nu_lambda0 sqrt(nu_lambda_var(i))]);

    [f,xi] = ksdensity(nu_lambda_S1(i,:));
    subplot(3,2,i)
    plot(xi,f)
    xlabel('\lambda')
end

fprintf('   ------------------------------------\n');
fprintf('Number of replications: %12.4f total \n',S);
fprintf('                        %12.4f discarded \n',S0);
fprintf('   ------------------------------------\n');

fprintf('   ------------------------------------\n');
fprintf('Accept.Ratio:  %8.4f\n\n', accept_ratio_rw)
fprintf('   ------------------------------------\n');

fprintf('Time elapsed (s): %12.2f \n',t);
fprintf('***************************************************************************\n\n\n');
